/* CalFolder internal component - Copyright (C) 2005 Rod Whiteley - Licensed under the Open Software License version 2.1 - Source at http://calendarhelp.mozdev.org/calfolder.html */
CalfoDialog = {
context: null,current: null,data: null,pref: {},res: null,ares: null,seq: null,iscal: null,isall: null,isfolder: false,folder: null,defaultColor: "f9f4ff",defaultCOLOR: "#F9F4FF",status: null,accept: function () {
if (this.referenceName && this.pref.name) this.referenceName.value = this.calendarName.value
if (this.referenceColor && this.pref.color) this.referenceColor.color = this.calendarColor.color
this.scan(false)
var ok = !this.acceptButton.disabled
if (ok) {
CalfoFilter.write()
this.data.write()
this.current.refresh()}
return ok},help: function () {
if (opener.openHelp) opener.openHelp(null, null, document)},init: function () {
this.context = opener.CalFolder.context
this.current = opener.CalFolder.current
this.data = opener.CalFolder.data
var p = opener.CalFolder.pref
this.pref.name = p.name
this.pref.color = p.color
this.pref.single = p.single
this.pref.palette = p.palette
this.res = window.arguments[0].QueryInterface(Components.interfaces.nsIRDFResource)
this.ares = this.data.allRes(this.res)
if (!opener.openHelp) document.documentElement.getButton("help").hidden = true
var typ = this.data.getType(this.res)
this.iscal = (typ =="cal")
this.isall = (typ =="all")
document.title = document.documentElement.getAttribute(this.iscal ? "caltitle" : "settitle")
if (this.iscal) {
document.getElementById("calendar-group").hidden = false
document.getElementById("reference-group").hidden = (this.ares == this.res)}
else if (this.isall) {
document.documentElement.insertBefore(
document.getElementById("info-panel").removeChild(document.getElementById("folder-group")),document.getElementById("status-box"))}
else {
document.getElementById("folder-tabbox").hidden = false}
if (this.iscal) {
this.calendarName = document.getElementById("calendar-name-text")
this.calendarColorCheck = document.getElementById("calendar-color-check")
this.calendarColor = document.getElementById("calendar-color")
this.calendarURLCheck = document.getElementById("calendar-url-check")
this.calendarURL = document.getElementById("calendar-url-text")
this.calendarRead = document.getElementById("calendar-read-check")
this.calendarWrite = document.getElementById("calendar-write-check")
this.calendarType = document.getElementById("calendar-type")
this.calendarTypeLabel = document.getElementById("calendar-type-label")
this.calendarDefault = document.getElementById("calendar-default-check")
this.calendarName.value = this.data.getName(this.ares)
var c = this.data.getColor(this.ares)
setTimeout('CalfoDialog.calendarColor.color = "#' + c.toUpperCase() + '"', 0)
if (c == this.defaultColor) {
this.calendarColor.setAttribute("disabled", "true")
this.calendarColorCheck.checked = false}
else {
this.calendarColor.removeAttribute("disabled")
this.calendarColorCheck.checked = true}
var u = this.data.getURI(this.ares)
if (/^moz-profile/.test(u)) {
this.calendarURL.value = ""
this.calendarURL.disabled = true
this.calendarType.disabled = true
this.calendarTypeLabel.disabled = true
this.calendarURLCheck.checked = false
this.calendarRead.disabled = true
this.calendarWrite.disabled = true}
else {
this.calendarURL.value = u
this.calendarURL.disabled = false
this.calendarURLCheck.checked = true
this.calendarRead.disabled = false
this.calendarWrite.disabled = false}
this.calendarDefault.checked = this.data.getMark(this.ares)
if (this.pref.palette) {
var cp = document.getElementsByTagName("colorpicker")
for (var i = 0; i < cp.length; ++i) cp[i].setAttribute("palettename", "calfolder")}
if (!this.isall) {
var f = this.data.getName(this.data.getSet(this.res))
var cap = document.getElementById("reference-caption")
cap.setAttribute("label",cap.getAttribute("label").replace(/%/, f))
this.referenceName = document.getElementById("reference-name-text")
this.referenceColorCheck = document.getElementById("reference-color-check")
this.referenceColor = document.getElementById("reference-color")
this.referenceDefault = document.getElementById("reference-default-check")
this.referenceName.value = this.data.getName(this.res)
if (this.pref.name) with (this.referenceName)
readonly = true, previousSibling.accessKey = ""
var c = this.data.getColor(this.res)
if (!c) c = this.defaultColor
setTimeout('CalfoDialog.referenceColor.color = "#' + c.toUpperCase() + '"', 0)
if (c == this.defaultColor) {
this.referenceColor.setAttribute("disabled", "true")
this.referenceColorCheck.checked = false}
else {
this.referenceColor.removeAttribute("disabled")
this.referenceColorCheck.checked = true}
if (this.pref.color) {
with (this.referenceColorCheck) {
setAttribute("disabled", "true")
setAttribute("readonly", "true")}
with (this.referenceColor) {
setAttribute("disabled", "true")
setAttribute("readonly", "true")
parentNode.previousSibling.accessKey = ""}}
this.referenceDefault.checked = this.data.getMark(this.res)}}
else {
this.isfolder = true
this.folder = opener.CalFolder.folders[this.res.Value]
this.folderName = document.getElementById("folder-name-text")
this.folderActive = document.getElementById("folder-active-check")
this.folderList = document.getElementById("folder-calendars-list")
this.folderName.value = this.data.getName(this.res)
this.folderActive.checked = this.data.getMark(this.res)
this.seq = this.data.seq(this.res)
var ena = this.data.seq(this.data.all).GetElements()
while (ena.hasMoreElements()) {
var r = ena.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var itm = document.createElement("listitem")
var enf = this.seq.GetElements()
var here = null
var val = r.Value
while (enf.hasMoreElements()) {
var rf = enf.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
if (this.data.getURI(rf) == this.data.getURI(r)) {
here = this.data.getName(rf)
val = rf.Value
break}}
var real = this.data.getName(r)
c = document.createElement("listcell")
c.setAttribute("type", "checkbox")
c.setAttribute("label", real)
c.setAttribute("value", val)
if (here) {
c.setAttribute("checked", "true")
c.setAttribute("here", "true")}
itm.appendChild(c)
if (here && here != real) {
c = document.createElement("listcell")
c.setAttribute("label", here)
itm.appendChild(c)}
this.folderList.appendChild(itm)}
this.titleTab = document.getElementById("title-tab")
this.titleText = document.getElementById("title-text")
this.titleRadio = document.getElementById("title-radio")
this.locationTab = document.getElementById("location-tab")
this.locationList = document.getElementById("location-list")
this.locationAll = document.getElementById("location-all")
this.categoryTab = document.getElementById("category-tab")
this.categoryList = document.getElementById("category-list")
this.categoryAll = document.getElementById("category-all")
this.descriptionTab = document.getElementById("description-tab")
this.descriptionText = document.getElementById("description-text")
this.descriptionRadio = document.getElementById("description-radio")
this.privacyTab = document.getElementById("privacy-tab")
this.privacyPublic = document.getElementById("privacy-public")
this.privacyPrivate = document.getElementById("privacy-private")
this.privacyConfidential = document.getElementById("privacy-confidential")
this.privacyAll = document.getElementById("privacy-all")
this.priorityTab = document.getElementById("priority-tab")
this.priorityLow = document.getElementById("priority-low")
this.priorityMedium = document.getElementById("priority-medium")
this.priorityHigh = document.getElementById("priority-high")
this.priorityNone = document.getElementById("priority-none")
this.priorityAll = document.getElementById("priority-all")
this.typeTab = document.getElementById("type-tab")
this.typeEvent = document.getElementById("type-event")
this.typeTodo = document.getElementById("type-todo")
this.typeJournal = document.getElementById("type-journal")
this.typeAll = document.getElementById("type-all")
this.dateTab = document.getElementById("date-tab")
this.startAfterDate = document.getElementById("start-after-date")
this.startBeforeDate = document.getElementById("start-before-date")
this.endAfterDate = document.getElementById("end-after-date")
this.endBeforeDate = document.getElementById("end-before-date")
this.allDay = document.getElementById("all-day-check")
this.statusTab = document.getElementById("status-tab")
this.statusTentative = document.getElementById("status-tentative")
this.statusConfirmed = document.getElementById("status-confirmed")
this.statusNeeds = document.getElementById("status-needs-action")
this.statusProcess = document.getElementById("status-in-process")
this.statusComplete = document.getElementById("status-completed")
this.statusCancelled = document.getElementById("status-cancelled")
this.statusAll = document.getElementById("status-all")
this.attendeesTab = document.getElementById("attendees-tab")
this.attendeesText = document.getElementById("attendees-text")
this.attendeesRadio = document.getElementById("attendees-radio")
this.attachmentTab = document.getElementById("attachment-tab")
this.attachmentText = document.getElementById("attachment-text")
this.attachmentRadio = document.getElementById("attachment-radio")
this.urlTab = document.getElementById("url-tab")
this.urlText = document.getElementById("url-text")
this.urlRadio = document.getElementById("url-radio")
this.customTab = document.getElementById("custom-tab")
this.customText = document.getElementById("custom-text")
this.customTest = document.getElementById("custom-test")
CalfoFilter.init()}
this.status = document.getElementById("status")
this.acceptButton = document.documentElement.getButton("accept")
this.cancelButton = document.documentElement.getButton("cancel")
this.acceptButton.setAttribute("default", "true")
this.acceptButton.focus()
this.acceptButton.parentNode.appendChild(document.createElement("resizer")).setAttribute("dir", "bottomright")
this.scan(true)
addEventListener(
"command",function (event) {CalfoDialog.logic(event)},true)
addEventListener(
"change",function (event) {CalfoDialog.logic(event)},true)
addEventListener(
"select",function (event) {CalfoDialog.logic(event)},true)
addEventListener(
"resize",function (event) {CalfoDialog.resize(event)},true)
addEventListener(
"mousedown",function (event) {CalfoDialog.mousedown(event)},true)
addEventListener(
"keypress",function (event) {CalfoDialog.keypress(event)},true)
sizeToContent()},_bad: {},inhibit: function (msg, elem) {
this._bad[elem.id] = {msg: msg, elem: elem}
var ok = !Boolean(msg)
if (ok) {
for (var id in this._bad) {
var b = this._bad[id]
if (b.msg) {
msg = b.msg
elem = b.elem
ok = false
break}}}
if (msg && msg.indexOf("%") >= 0) msg = CalfoFilter.date.message(msg)
this.status.value = msg || " "
this.acceptButton.disabled = !ok
if (ok) this.acceptButton.setAttribute("default", "true")
else this.acceptButton.removeAttribute("default")},keypress: function (event) {
if ((event.keyCode == event.DOM_VK_ENTER || event.keyCode == event.DOM_VK_RETURN)
&& !event.target.hasAttribute("multiline")) {
this.acceptButton.click()
event.stopPropagation()}
else if (event.altKey) {
var f = document.commandDispatcher.focusedElement
var k = String.fromCharCode(event.charCode).toUpperCase()
if (k != f.getAttribute("accesskey")) {
var ee = document.getElementsByAttribute("accesskey", k)
for (var i = 0; i < ee.length; ++i) {
var e = ee[i]
e.focus()
if (document.commandDispatcher.focusedElement) break}}}},listSelect: function (event) {
var list = event.target
if (list.localName == "listitem") list = list.parentNode
if (event.type == "keypress" && list.localName != "listbox") return
if (event.type == "click" || event.charCode == 32) {
var c = list.selectedItem
if (!c) return
if (c.firstChild) {
c = c.firstChild
if (c.hasAttribute("checked")) c.removeAttribute("checked")
else c.setAttribute("checked", "true")}}
else if (event.charCode == 97) {
var n = list.getRowCount()
for (var i = 0; i < n; ++i) {
var c = list.getItemAtIndex(i)
if (c.firstChild) c = c.firstChild
c.setAttribute("checked", "true")}}
this.logic({target:list})
if (list.id == "folder-calendars-list") CalfoFilter.load.reset()},_width: 0,_height: 0,resize: function (event) {
if (!this._width)
this._width = outerWidth, this._height = outerHeight
else if (outerWidth != this._width || outerHeight != this._height)
resizeTo(Math.max(outerWidth, this._width), Math.max(outerHeight, this._height))},logic: function (event) {
var elem = event.target
var chk = elem.checked
switch (elem.id) {
case "calendar-name-text":
if (/\S/.test(elem.value)) {
this.inhibit(null, elem)
if (this.referenceName && this.pref.name)
this.referenceName.value = elem.value.replace(/^\s*|\s*$/g, "")}
else this.inhibit(elem.getAttribute("errormsg"), elem)
break
case "calendar-color-check":
with (this.calendarColor) {
if (chk) {
removeAttribute("disabled")
color = getAttribute("was") || this.defaultCOLOR}
else {
setAttribute("was", color)
color = this.defaultCOLOR
setAttribute("disabled", "true")}
if (this.referenceColor && this.pref.color) {
this.referenceColorCheck.checked = chk
this.referenceColor.color = color}}
break
case "calendar-color":
this.calendarColorCheck.checked = true
elem.removeAttribute("disabled")
if (this.referenceColor && this.pref.color) this.referenceColor.color = elem.color
break
case "calendar-url-check":
with (this.calendarURL) {
if (chk) {
disabled = false
value = getAttribute("was")}
else {
setAttribute("was", value)
value = ""
disabled = true}
this.logic({target: this.calendarURL})}
with (this.calendarRead) {
if (chk) {
disabled = false
checked = getAttribute("was") == "true"}
else {
setAttribute("was", checked)
checked = false
disabled = true}}
with (this.calendarWrite) {
if (chk) {
disabled = false
checked = getAttribute("was") == "true"}
else {
setAttribute("was", checked)
checked = false
disabled = true}}
with (this.calendarType) {
if (chk) {
disabled = false
value = getAttribute("was")}
else {
setAttribute("was", value)
value = null
disabled = true}}
this.calendarTypeLabel.disabled = !chk
if (chk) {
this.logic({target: this.calendarWrite})
this.calendarURL.focus()}
break
case "calendar-url-text":
var v = elem.value.replace(/^\s*|\s*$/, "")
if (v == "" || /^(?:file|ftp|http|webcal):\/{2}/.test(v)) {
this.inhibit(null, elem)
if (/^file:|^ftp:/.test(v)) {
this.calendarType.value = "ical"
this.calendarType.disabled = true
this.calendarType.setAttribute("readonly", "true")}
else {
this.calendarType.removeAttribute("readonly")
this.calendarType.disabled = false}}
else this.inhibit(elem.getAttribute("errormsg"), elem)
break
case "calendar-read-check":
if (!elem.checked) this.calendarWrite.checked = true
break
case "calendar-write-check":
if (!elem.checked) this.calendarRead.checked = true
break
case "reference-name-text":
break
case "reference-color-check":
with (this.referenceColor) {
if (elem.checked) {
removeAttribute("disabled")
color = getAttribute("was") || this.defaultCOLOR}
else {
setAttribute("was", color)
color = this.defaultCOLOR
setAttribute("disabled", "true")}}
break
case "reference-color":
this.referenceColorCheck.checked = true
this.referenceColor.removeAttribute("disabled")
break
case "folder-name-text":
if (/\S/.test(elem.value)) this.inhibit(null, elem)
else this.inhibit(elem.getAttribute("errormsg"), elem)
break
case "calfolder-properties":
break
case "property-list":
document.getElementById("value-deck").selectedIndex = elem.selectedIndex
break
case "folder-tabs":

break
case "title-text":
this.tabStyle(this.titleTab, elem.value)
break
case "title-radio":
break
case "location-list":

var c = elem.getElementsByAttribute("checked", "true").length > 0
this.locationAll.checked = !c
this.tabStyle(this.locationTab, c)
break
case "location-load":
CalfoFilter.load.init(elem)
break
case "location-all":
if (elem.checked) {
var i = document.getElementById("location-list").firstChild
while (i) {
if (i.hasAttribute("checked")) i.removeAttribute("checked")
i = i.nextSibling}
this.tabStyle(this.locationTab, false)}
break
case "category-list":
with (this.categoryAll) if (hasAttribute("checked")) removeAttribute("checked")
break
case "category-load":
CalfoFilter.load.init()
break
case "category-all":
if (elem.checked) {
var i = document.getElementById("category-list").firstChild
while (i) {
if (i.hasAttribute("checked")) i.removeAttribute("checked")
i = i.nextSibling}}
break
case "description-text":
this.tabStyle(this.descriptionTab, elem.value)
break
case "description-radio":
break
case "privacy-public":
case "privacy-private":
case "privacy-confidential":
if (elem.checked) {
this.privacyAll.checked = false
this.tabStyle(this.privacyTab, true)}
else if (!this.privacyPublic.checked
&& !this.privacyPrivate.checked
&& !this.privacyConfidential.checked) {
this.privacyAll.checked = true
this.tabStyle(this.privacyTab, false)}
break
case "privacy-all":
if (elem.checked) {
this.privacyPublic.checked = false
this.privacyPrivate.checked = false
this.privacyConfidential.checked = false}
this.tabStyle(this.privacyTab, !elem.checked)
break
case "priority-low":
case "priority-medium":
case "priority-high":
case "priority-none":
if (elem.checked) {
this.priorityAll.checked = false
this.tabStyle(this.priorityTab, true)}
else if (!this.priorityLow.checked
&& !this.priorityMedium.checked
&& !this.priorityHigh.checked
&& !this.priorityNone.checked) {
this.priorityAll.checked = true
this.tabStyle(this.priorityTab, false)}
break
case "priority-all":
if (elem.checked) {
this.priorityLow.checked = false
this.priorityMedium.checked = false
this.priorityHigh.checked = false
this.priorityNone.checked = false}
this.tabStyle(this.priorityTab, !elem.checked)
break
case "type-event":
case "type-todo":
case "type-journal":
if (elem.checked) {
this.typeAll.checked = false
this.tabStyle(this.typeTab, true)}
else if (!this.typeEvent.checked
&& !this.typeTodo.checked
&& (this.typeJournal.disabled || !this.typeJournal.checked)) {
this.typeAll.checked = true
this.tabStyle(this.typeTab, false)}
break
case "type-all":
if (elem.checked) {
this.typeEvent.checked = false
this.typeTodo.checked = false
this.typeJournal.checked = false}
this.tabStyle(this.typeTab, !elem.checked)
break
case "start-after-date":
case "start-before-date":
case "end-after-date":
case "end-before-date":
var v = elem.value.replace(/\s*/g, "")
var p = v? CalfoFilter.date.parse(v) : true
if (p) this.inhibit(null, elem)
else this.inhibit(elem.getAttribute("errormsg"), elem)
break
case "status-tentative":
case "status-confirmed":
case "status-needs-action":
case "status-in-process":
case "status-completed":
case "status-cancelled":
if (elem.checked) {
this.statusAll.checked = false
this.tabStyle(this.statusTab, true)}
else if (!this.statusTentative.checked
&& !this.statusConfirmed.checked
&& !this.statusNeeds.checked
&& !this.statusProcess.checked
&& !this.statusComplete.checked
&& !this.statusCancelled.checked) {
this.statusAll.checked = true
this.tabStyle(this.statusTab, false)}
break
case "status-all":
if (elem.checked) {
this.statusTentative.checked = false
this.statusConfirmed.checked = false
this.statusNeeds.checked = false
this.statusProcess.checked = false
this.statusComplete.checked = false
this.statusComplete.checked = false
this.statusCancelled.checked = false}
this.tabStyle(this.statusTab, !elem.checked)
break
case "custom-text":
this.tabStyle(this.customTab, /\S/.test(elem.value))
var ok = this.scriptTest(this.customText.value, true)
if (ok) this.inhibit(null, elem)
else this.inhibit(elem.getAttribute("errormsg"), elem)
break
case "custom-test":
this.scriptTest(this.customText.value, false)
break
default:
}},tabStyle: function (tab, stuff) {
tab.className = stuff? "stuff" : ""},scriptTest: function (s, quiet) {
if (s == '' || s == 'false') return true
var f = {script: s, error: null}
opener.CalFolder.sandbox.run(f, this._scriptTestItem, false)
if (quiet) return f.error == null
else if (f.error) {
Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService).alert(self, opener.CalFolder.sandbox.errorTitle, f.error)
this.customText.focus()
return false}
else {
this.customTest.disabled = true
setTimeout(function () {
CalfoDialog.customTest.disabled = false
CalfoDialog.customText.focus()}, 600)
return true}},_scriptTestItem: {
alarmTime: "",attachments: [],attendees: [],getProperty: function (p) {return ""},creationDate: "",generation: "",id: "",organizer: "",priority: "",recurrenceId: "",recurrenceInfo: [],status: "",title: "",url: ""},mousedown: function (event) {
if (event.target == this.referenceColor && this.pref.color) event.stopPropagation()},_data: {},scan: function (init) {
const tags = ["textbox", "checkbox", "radiogroup", "menulist", "colorpicker", "listbox"]
var ga = []
var gps = document.getElementsByTagName("groupbox")
for (var i = 0; i < gps.length; ++i) {
var gp = gps[i]
if (gp.id && !gp.hidden) ga.push(gps[i])}
if (this.isfolder) {
var gps = document.getElementsByTagName("vbox")
for (var i = 0; i < gps.length; ++i) ga.push(gps[i])}
for (var i = 0; i < ga.length; ++i) {
var gp = ga[i]
for (var j = 0; j < tags.length; ++j) {
var es = gp.getElementsByTagName(tags[j])
for (var k = 0; k < es.length; ++k) {
var e = es[k]
if (!e) continue
if (e.hasAttribute("disabled") && !e.hasAttribute("readonly")) continue
switch (e.localName) {
case "textbox":
if (init) var v = e.value
else {
var v = this.validate(e.id, e.value)
if (v == null) {
this.logic({target: e})
return}}
break
case "checkbox":
var v = e.checked
break
case "colorpicker":
var v = e.color
break
case "listbox":
var v = []
var lis = e.getElementsByAttribute("type", "checkbox")
for (var l = 0; l < lis.length; ++l) {
if (lis[l].getAttribute("checked")) v.push(lis[l].getAttribute("label"))}
v = v.join("|")
break
default:
var v = e.value}
if (init) this._data[e.id] = v
else if (this._data[e.id] != v) this.write(e.id, v)}}}},validate: function (id, val) {
switch (id) {
case "calendar-name-text":
case "folder-name-text":
if (/\S/.test(val)) return val.replace(/^\s*|\s*$/g, "")
break
case "reference-name-text":
val = val.replace(/^\s*|\s*$/g, "")
if (val == "") val = this.calendarName.value
if (/\S/.test(val)) return val.replace(/^\s*|\s*$/g, "")
break
case "calendar-url-text":
if (val == "") {
this.checkURL.checked = false
return val}
else if (/^(?:file|ftp|http|webcal):\/{2}/.test(val))
return val.replace(/\s*$/, "")
break
case "start-after-date":
case "start-before-date":
case "end-after-date":
case "end-before-date":
return (val == "")? "" : CalfoFilter.date.parse(val.replace(/\s*/g, ""))
break
default:
return val}},write: function (id, val) {
switch (id) {
case "calendar-name-text":
this.data.setName(this.ares, val)
break
case "calendar-color-check":
if (!val) this.data.setColor(this.ares, this.defaultColor)
break
case "calendar-color":
this.data.setColor(this.ares, val.replace(/^#/, "").toLowerCase())
break
case "calendar-default-check":
if (val) this.data.setDefaultMark(this.ares, this.data.seq(this.data.getSet(this.ares)))
else this.data.clearMark(this.ares)
break
case "reference-name-text":
this.data.setName(this.res, val)
break
case "reference-color-check":
if (!val) this.data.setColor(this.res, this.defaultColor)
break
case "reference-color":
this.data.setColor(this.res, val.replace(/^#/, "").toLowerCase())
break
case "reference-default-check":
if (val) this.data.setDefaultMark(this.res, this.data.seq(this.data.getSet(this.res)))
else this.data.clearMark(this.res)
break
case "folder-name-text":
this.data.setName(this.res, val)
break
case "folder-active-check":
this.context.select(this.res, NaN)
break
case "folder-calendars-list":
var lis = this.folderList.getElementsByAttribute("type", "checkbox")
for (var l = 0; l < lis.length; ++l) {
var want = lis[l].hasAttribute("checked")
var got = lis[l].hasAttribute("here")
var res = this.data.RDF.GetResource(lis[l].getAttribute("value"))
if (want && !got) {
this.data.insert(this.seq, this.data.newCal(this.data.cal(res)), Infinity, true)}
else if (got && !want) {
this.data.remove(res, this.seq)}}
break
case "title-text":
CalfoFilter.set("SUMMARY", null, val)
break
case "title-radio":
CalfoFilter.set("SUMMARY", val, null)
break
case "location-list":
CalfoFilter.set("LOCATION", CalfoFilter.MODE_LIST, val)
break
case "category-list":
CalfoFilter.set("CATEGORIES", CalfoFilter.MODE_LIST, val)
break
case "description-text":
CalfoFilter.set("DESCRIPTION", null, val)
break
case "description-radio":
CalfoFilter.set("DESCRIPTION", val, null)
break
case "privacy-public":
case "privacy-private":
case "privacy-confidential":
CalfoFilter.set("CLASS", val, id.replace(/^.*-/, "").toUpperCase())
break
case "priority-low":
CalfoFilter.set("PRIORITY", val, "1|2|3|4")
break
case "priority-medium":
CalfoFilter.set("PRIORITY", val, "5")
break
case "priority-high":
CalfoFilter.set("PRIORITY", val, "6|7|8|9")
break
case "priority-none":
CalfoFilter.set("PRIORITY", val, "0")
break
case "type-event":
case "type-todo":
case "type-journal":
CalfoFilter.set("TYPE", val, id.replace(/^.*-/, "").toUpperCase())
break
case "start-after-date":
CalfoFilter.set("START", CalfoFilter.MODE_AFTER, val)
break
case "start-before-date":
CalfoFilter.set("START_bis", CalfoFilter.MODE_BEFORE, val)
break
case "end-after-date":
CalfoFilter.set("_END", CalfoFilter.MODE_AFTER, val)
break
case "end-before-date":
CalfoFilter.set("_END_bis", CalfoFilter.MODE_BEFORE, val)
break
case "all-day-check":
CalfoFilter.set("ALL-DAY", CalfoFilter.MODE_CHECK, val)
break
case "status-tentative":
case "status-confirmed":
case "status-needs-action":
case "status-in-process":
case "status-completed":
case "status-cancelled":
CalfoFilter.set("STATUS", val, id.replace(/^status-/, "").toUpperCase())
break
case "attendees-text":
CalfoFilter.set("ATTENDEES", null, val)
break
case "attendees-radio":
CalfoFilter.set("ATTENDEES", val, null)
break
case "attachment-text":
CalfoFilter.set("ATTACHMENT", null, val)
break
case "attachment-radio":
CalfoFilter.set("ATTACHMENT", val, null)
break
case "url-text":
CalfoFilter.set("URL", null, val)
break
case "url-radio":
CalfoFilter.set("URL", val, null)
break
case "custom-text":
CalfoFilter.set("SCRIPT", CalfoFilter.MODE_SCRIPT, val)
break
case "location-all":
case "category-all":
case "privacy-all":
case "priority-all":
case "type-all":
case "status-all":

break
default:
dump("unknown write: " + id + " = " + val + "\n")}}}
CalfoFilter = {
MODE_ANY: 1,MODE_ALL: 2,MODE_PHRASE: 3,MODE_REGEX: 4,MODE_LIST: 5,MODE_BEFORE: 6,MODE_AFTER: 7,MODE_CHECK: 8,MODE_SCRIPT: 9,CM: Components.classes["@mozilla.org/calendar/manager;1"].getService(Components.interfaces.calICalendarManager),prefcat: {},cat: {},loc: {},init: function () {
this.date.init()
var p = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("calendar.categories.").getCharPref("names").split(",")
for (var i = 0; i < p.length; ++i) {
var cat = p[i].replace(/^\s*|\s*$/g, "")
if (cat) this.prefcat[cat.toUpperCase()] = cat}
var a = CalfoDialog.data.getCriteria(CalfoDialog.res)
for (var c in a) {
this._crit[c] = {mode: a[c].mode, value: a[c].value}
switch (c) {
case "SUMMARY":
CalfoDialog.titleText.value = a[c].value
CalfoDialog.titleRadio.value = a[c].mode
CalfoDialog.tabStyle(CalfoDialog.titleTab, true)
break
case "LOCATION":
var la = a[c].value.split("|")
for each (var l in la) if (l) this.loc[l.toUpperCase()] = l
CalfoDialog.tabStyle(CalfoDialog.locationTab, true)
CalfoDialog.locationAll.checked = false
break
case "CATEGORIES":
var ca = a[c].value.split("|")
for each (var c in ca) if (c) this.cat[c.toUpperCase()] = c
CalfoDialog.tabStyle(CalfoDialog.categoryTab, true)
CalfoDialog.categoryAll.checked = false
break
case "DESCRIPTION":
CalfoDialog.descriptionText.value = a[c].value
CalfoDialog.descriptionRadio.value = a[c].mode
CalfoDialog.tabStyle(CalfoDialog.descriptionTab, true)
break
case "CLASS":
var ss = a[c].value.toLowerCase().split("|")
for each (var s in ss) document.getElementById("privacy-" + s).checked = true
CalfoDialog.tabStyle(CalfoDialog.privacyTab, true)
CalfoDialog.privacyAll.checked = false
break
case "PRIORITY":
var ss = a[c].value.toLowerCase().split("|")
for each (var s in ss) {
switch (s) {
case "1":
CalfoDialog.priorityLow.checked = true
break
case "5":
CalfoDialog.priorityMedium.checked = true
break
case "9":
CalfoDialog.priorityHigh.checked = true
break
case "0":
CalfoDialog.priorityNone.checked = true
break}}
CalfoDialog.tabStyle(CalfoDialog.priorityTab, true)
CalfoDialog.priorityAll.checked = false
break
case "TYPE":
var ss = a[c].value.toLowerCase().split("|")
for each (var s in ss) document.getElementById("type-" + s).checked = true
CalfoDialog.tabStyle(CalfoDialog.typeTab, true)
CalfoDialog.typeAll.checked = false
break
case "START":
case "START_bis":
if (a[c].mode == this.MODE_AFTER) CalfoDialog.startAfterDate.value = this.date.format(a[c].value)
else CalfoDialog.startBeforeDate.value = this.date.format(a[c].value)
CalfoDialog.tabStyle(CalfoDialog.dateTab, true)
break
case "_END":
case "_END_bis":
if (a[c].mode == this.MODE_AFTER) CalfoDialog.endAfterDate.value = this.date.format(a[c].value)
else CalfoDialog.endBeforeDate.value = this.date.format(a[c].value)
CalfoDialog.tabStyle(CalfoDialog.dateTab, true)
break
case "STATUS":
var ss = a[c].value.toLowerCase().split("|")
for each (var s in ss) document.getElementById("status-" + s).checked = true
CalfoDialog.tabStyle(CalfoDialog.statusTab, true)
CalfoDialog.statusAll.checked = false
break
case "SCRIPT":
CalfoDialog.customText.value = a[c].value
CalfoDialog.tabStyle(CalfoDialog.customTab, true)
break
default:
dump("bad criterion " + c + ": " + a[c].mode + " " + a[c].value + "\n")}}
var box = document.getElementById("filter-panel").firstChild
var t = box.firstChild.firstChild
while (t) {
if (t.className == "stuff") {
box.selectedTab = t
break}
t = t.nextSibling}
this.load.display(this.prefcat, this.loc)},date: {
_form: "",_sep: "",_zero: false,init: function () {
var d = Components.classes["@mozilla.org/intl/scriptabledateformat;1"].getService(Components.interfaces.nsIScriptableDateFormat).FormatDate("", 2, 2002, 11, 3)
this._zero = (d.indexOf("03") >= 0)
d = d.match(/([123])(\D)/)
var f = parseInt(d[1])
this._form = f == 1? ["m", "d", "y"] : f == 2? ["y", "m", "d"] : ["d", "m", "y"]
this._sep = d[2]},_pad: function (n) {
n = n.toString()
return this._zero && n.length == 1? "0" + n : n},message: function (m) {
var r = {y: "yyyy", m: "m", d: "d"}
return m.replace(/%/, r[this._form[0]] + this._sep + r[this._form[1]] + this._sep + r[this._form[2]])},parse: function (v) {
try {
var v = v.split(this._sep), r = {}
for (var i = 0; i < 3; ++i) r[this._form[i]] = v[i]
if (!r.y || !r.m || !r.d) return null
if (r.y < 50) r.y += 2000
if (r.y < 100) r.y += 1900
if (r.y < 1700 || r.y > 2999) return null
if (r.m > 12 || r.m < 0 || r.d > 31 || r.d < 0) return null}
catch (ex) {return null}
return r.y + this._pad(r.m) + this._pad(r.d)},format: function (v) {
var a = v.match(/(\d{4})(\d{2})(\d{2})/)
var r = {y: a[1], m: a[2], d: a[3]}
return r[this._form[0]] + this._sep + r[this._form[1]] + this._sep + r[this._form[2]]}},load: {
button: null,catButton: null,locButton: null,init: function (button) {
this.button = button
this.catButton = document.getElementById("category-load")
this.locButton = document.getElementById("location-load")
setCursor("wait")
setTimeout(function () {CalfoFilter.load.work()}, 0)},display: function (cat, loc) {
var cl = document.getElementById("category-list")
while (cl.lastChild) cl.removeChild(cl.lastChild)
var ca = []
for (var c in cat) ca.push(c)
ca.sort()
for each (var c in ca) {
with (cl.appendChild(document.createElement("listitem"))) {
setAttribute("label", cat[c])
setAttribute("type", "checkbox")
if (CalfoFilter.cat[c]) setAttribute("checked", "true")}}
var ll = document.getElementById("location-list")
while (ll.lastChild) ll.removeChild(ll.lastChild)
var la = []
for (var l in loc) la.push(l)
la.sort()
for each (var l in la) {
with (ll.appendChild(document.createElement("listitem"))) {
setAttribute("label", loc[l])
setAttribute("type", "checkbox")
if (CalfoFilter.loc[l]) setAttribute("checked", "true")}}},work: function () {
var lis = CalfoDialog.folderList.getElementsByAttribute("type", "checkbox")
CalfoFilter._listener.init()
for (var l = 0; l < lis.length; ++l) {
if (lis[l].hasAttribute("checked")) {
var res = CalfoDialog.data.RDF.GetResource(lis[l].getAttribute("value"))
CalfoDialog.data.cal(res).getItems(0xffff, 0, null, null, CalfoFilter._listener)}}},finish: function (ca, la) {
if (this.locButton) {
this.locButton.disabled = true
this.catButton.disabled = true}
document.getElementById(this.button.id.replace(/-load/, "-list")).focus()
setCursor("default")},reset: function () {
if (this.locButton) {
this.locButton.disabled = false
this.catButton.disabled = false}}},_crit: {},set: function (prop, mode, value) {
dump("CalfoFilter.set " + prop + " " + mode + " " + value + "\n")
if (!this._crit[prop]) this._crit[prop] = {mode: 0, value: ""}
if (mode === true) {
var v = this._crit[prop].value
this._crit[prop].value += (v == "" ? "" : "|") + value
this._crit[prop].mode = this.MODE_LIST}
else if (mode === false) {
var v0 = this._crit[prop].value.split("|"), v1 = []
var dd = value.split("|")
for each (var v in v0) {
var ok = true
for each (var d in dd) if (v == d) ok = false
if (ok) v1.push(v)}
this._crit[prop].value = v1.join("|")}
else {
if (value != null) this._crit[prop].value = value
if (mode != null) this._crit[prop].mode = mode}
dump(" i.e. " + prop + " " + this._crit[prop].mode + " '" + this._crit[prop].value + "'\n")},write: function () {
for (var p in this._crit) {
var c = this._crit[p]
CalfoDialog.data.setCriterion(CalfoDialog.res, p, (c.mode || 1), c.value)}
CalfoDialog.folder.rebuild()},_listener: {
cat: null,loc: null,init: function () {
this.cat = {}, this.loc = {}
for (var c in CalfoFilter.cat) this.cat[c] = CalfoFilter.cat[c]
for (var c in CalfoFilter.loc) this.loc[c] = CalfoFilter.loc[c]},onOperationComplete: function () {
CalfoFilter.load.display(this.cat, this.loc)
CalfoFilter.load.finish()},onGetResult: function (cal, status, type, detail, count, data) {
for (var i = 0; i < count; ++i) {
var cat = data[i].getProperty("CATEGORIES")
if (cat) {
cat = cat.replace(/^\s*|\s*$/g, "")
if (cat) this.cat[cat.toUpperCase()] = cat}
var loc = data[i].getProperty("LOCATION")
if (loc) {
loc = loc.replace(/^\s*|\s*$/g, "")
if (loc) this.loc[loc.toUpperCase()] = loc}}}}}
